'use strict';

exports.__esModule = true;
exports.HEADER = undefined;
exports.remove = remove;

var _regexpEscape = require('../../utils/regexp-escape');

var _regexpEscape2 = _interopRequireDefault(_regexpEscape);

var _internalProperties = require('../../processing/dom/internal-properties');

var _internalProperties2 = _interopRequireDefault(_internalProperties);

var _instruction = require('./instruction');

var _instruction2 = _interopRequireDefault(_instruction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PREFIX = '/*hammerhead|script-processing-header|start*/'; // -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var POSTFIX = '/*hammerhead|script-processing-header|end*/';

var HEADER = exports.HEADER = [PREFIX, 'var __w$= typeof window!=="undefined"&&window;', '__w$ && __w$["' + _internalProperties2.default.processDomMethodName + '"] && __w$["' + _internalProperties2.default.processDomMethodName + '"]();', 'var ' + _instruction2.default.getLocation + '=__w$?__w$.' + _instruction2.default.getLocation + ':function(l){return l},', _instruction2.default.setLocation + '=__w$?__w$.' + _instruction2.default.setLocation + ':function(l,v){return l = v},', _instruction2.default.setProperty + '=__w$?__w$.' + _instruction2.default.setProperty + ':function(o,p,v){return o[p] = v},', _instruction2.default.getProperty + '=__w$?__w$.' + _instruction2.default.getProperty + ':function(o,p){return o[p]},', _instruction2.default.callMethod + '=__w$?__w$.' + _instruction2.default.callMethod + ':function(o,p,a){return o[p].apply(o,a)},', _instruction2.default.getEval + '=__w$?__w$.' + _instruction2.default.getEval + ':function(e){return e},', _instruction2.default.processScript + '=__w$?__w$.' + _instruction2.default.processScript + ':function(s){return s};', POSTFIX, '\n'].join('');

// NOTE: IE removes trailing newlines in script.textContent,
// so a trailing newline in RegExp is optional
var HEADER_RE = new RegExp((0, _regexpEscape2.default)(PREFIX) + '[\\S\\s]+?' + (0, _regexpEscape2.default)(POSTFIX) + '\n?', 'i');

function remove(code) {
    return code.replace(HEADER_RE, '');
}