'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

var _replaceNode = require('./replace-node');

var _replaceNode2 = _interopRequireDefault(_replaceNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Transform:
// new Function(params..., body); -->
// new Function(params..., __proc$Script(body));

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.NewExpression],

    condition: function condition(node) {
        return node.callee.name === 'Function' && node.arguments.length;
    },

    run: function run(node) {
        var lastArgIndex = node.arguments.length - 1;
        var newArg = (0, _nodeBuilder.createProcessScriptMethCall)(node.arguments[lastArgIndex]);

        (0, _replaceNode2.default)(node.arguments[lastArgIndex], newArg, node, 'arguments');

        return null;
    }
}; // -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

module.exports = exports['default'];